'use strict';

var RegistraCertificadoController = angular.module('RegistraCertificadoController', []);

RegistraCertificadoController.controller('RegistraCertificadoCtrl', ['$scope', '$rootScope', 'Compra', 'UploadApp', 'CacheApp',
  ($scope, $rootScope, Compra, UploadApp, CacheApp) => {

    $scope.salvarCertificado = (item) => {
        console.log(item)
        if (item.file) {
            item.progress = 0;
            var params ={
                File: item.file,
                IdCliente: $scope.sessao.ContaAdmin ? $scope.sessao.IdClienteAdmin : $scope.sessao.IdCliente,
                Cnpj: item.Cnpj,
                Senha: item.Senha,
                DataInicio: item.DataInicio
            }
            // console.log(params)
            UploadApp.uploadCertificadoA1(params,
                (progress) => {
                    item.progress = progress;
                },
                (result) => {
                    item.progress = null;
                    // $scope.alterar = false;
                    setTimeout(() => {
                        $scope.msgBoxSucesso("Certificado Cadastrado!", 'Recebemos seu certificado A1 e estamos processando as informações. Em até 24 horas, todos os seus lançamentos serão devidamente baixados para o VIGHA.', 
                        () => {
                            $scope.getListaCertificado()
                            $rootScope.$broadcast('atualizaListaCertificado', {})
                        })}, 2000);
                },
                (error) => {}
            );
        }
    }

    $scope.adicionarCertificado = () => {
        $scope.listaCertificado.unshift({
            IdCertificado: 0,
            Cnpj: '',
            DataInicio: $scope.DataInicioProc.toISOString(),
            Novo: true,
            // checked: true
        })
    }

    $scope.cancelarCertificado = (item) => {
        if (item.IdCertificado == 0) {
            var idx = $scope.listaCertificado.indexOf(item)
            $scope.listaCertificado.splice(idx, 1);
        }
        else
            item.Novo = !item.Novo;
    }

    $scope.delCertificado = (item) => {
        var params = {
            IdCertificado: item.IdCertificado
        }
        $scope.msgBoxPergunta("Certificado A1", ' Confirma exclusão?'
        , () => {
            Compra.delCertificado(params,
                (data) => {
                    $scope.getListaCertificado()
                    $rootScope.$broadcast('atualizaListaCertificado', {})
                });
        }
        , () => {
        });
    }

    $scope.getListaCertificado = () => {
        var params = {
            IdCliente: $scope.sessao.ContaAdmin ? $scope.sessao.IdClienteAdmin : $scope.sessao.IdCliente
        }
        Compra.getCertificados(params,
            (data) => {
                $scope.listaCertificado = data.Instance
            });
    }


    $('#BoxCertificado').on('shown.bs.modal', function (e) {
        $scope.sessao = CacheApp.getSessao();
        $scope.getListaCertificado();

        $('#BoxCertificado').off('show.bs.modal');
    });

  }]);
